=== pkg/linux/arch/PKGBUILD ===
# Maintainer: Stefan Husmann <stefan-husmann@t-online.de>
# Contributor: Sergey Malkin  <adresatt@gmail.com>

pkgname=nemu-git
pkgver=2.6.0.r78.g18f79a4
pkgrel=1
pkgdesc="ncurses interface for QEMU"
arch=('i686' 'x86_64')
url="https://github.com/nemuTUI/nemu"
license=('custom:BSD')
depends=('libarchive' 'libxml2' 'qemu-headless')
makedepends=('git')
optdepends=('tigervnc: for vncviewer' 'virt-viewer: for remote-viewer')
provides=('nemu')
conflicts=('nemu')
source=("git+$url.git")
md5sums=('SKIP')

pkgver() {
  cd "${pkgname%-git}"
  git describe | tr -d v |sed 's+-+.r+' | tr - .
}

build() {
  cd "${pkgname%-git}"
  [[ -d build ]] || mkdir build
  cd build
  cmake ../
  make
}

package() {
  cd "${pkgname%-git}"/build
  make DESTDIR="$pkgdir/" install
  mv "$pkgdir"/usr/local/* "$pkgdir"/usr
  rmdir "$pkgdir"/usr/local
  install -Dm644 ../LICENSE "$pkgdir"/usr/share/licenses/$pkgname/LICENSE
}
# Maintainer: MaksVal <valmaxster@gmail.com> -> https://github.com/MaksVal
# Contributor: Fabio 'Lolix' Loli <fabio.loli@disroot.org> -> https://github.com/FabioLolix
# Contributor: Sergey Malkin  <adresatt@gmail.com>
