=== pkg/linux/debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_CMAKE_EXTRA_FLAGS := \
	-DNM_WITH_DBUS=ON \
	-DNM_WITH_NETWORK_MAP=ON \
	-DNM_WITH_OVF_SUPPORT=ON \
	-DNM_WITH_REMOTE=ON \
	-DNM_WITH_SPICE=ON \
	-DNM_WITH_VNC_CLIENT=ON \
	-DNM_WITH_USB=ON
