=== pkg/linux/debian/watch ===
version=4
opts="pgpmode=none"
https://bitbucket.org/PascalRD/nemu/downloads?tab=tags \
	.*/get/[vV]?(\d\S+)\.tar\.gz debian uupdate
